#include "flex.h"


int vtsetnull(); static int (*dummy)() = vtsetnull;
extern USERFUNCS inv[];
USEREXITS userexits[] = { 
"inv", inv,
 0, 0 };

static int befsave();
static int showsignature();
static int getsignature();


USERFUNCS inv[] = {
"befsave", befsave,
"showsignature", showsignature,
"getsignature", getsignature,
 0, 0 };

#line 44  "inv.flx"

#define MAXIMAGESIZE 4048
char sigbuf[MAXIMAGESIZE + 2]; 

/**
main(argc, argv)
int  argc;
char *argv[];
{

   flex(argc, argv);
   move("/tmp/junk.jpeg", @invoice.signature);
   flexload( argv[1]);
   flob_create(0L, 0L);
   flex(argc, argv);
   readfilectl();
   lockfilectl();
   msggerr("wait");
   flob_saverec( @invoice);
   fxabort(0);
}
**/


static int befsave()
{
    char objectpath[100];

/**
    if (flob_save($invoicescreen.signature, objectpath) < 0) {
       msggerr(msgbuf);
       return(-1);
       }
    move(objectpath, @invoicescreen.signature);
    tmapfld(@invoicescreen.signature);
**/
    return(0);
}


static aftsave()
{

/**
   int i;
   for (i=0; i < 11000; ++i) {
       move("/tmp/junk.jpeg", @invoice.signature);
       flob_savefld(@invoice.signature);
       sprintf(msgbuf, "%d) %s", i, $invoice.signature); 
       msgstat(msgbuf);
       }
**/
   return(0);
}


static int showsignature()
{

     if (flob_display((getsfchar( &ghdhead.hdSfptr[5] ,0 ,0 ,0))) < 0) {
        msggerr(msgbuf);
        return(-1);
        }
     return(0);
}

#define MAXIPADDRESS  60

static int getsignature()
{
    long size;
    char flobpath[FLOBSIZE+1];
    static int firsttime = YES;
    static char ipaddress[MAXIPADDRESS + 1];
    static long ipport;
    static int readagainflag = NO;

    if (firsttime) {
        getClientAddress(ipaddress, &ipport);
        firsttime = NO;
        tmrefresh();
        }

/**
  readagain:
**/
    size = readsignature(ipaddress, ipport, sigbuf, MAXIMAGESIZE);
    if (size == 0) {
       msggerr("@No signature captured."); // ESCAPE key probably pressed
       return(0);
       }
/**
    if (size == -2 && readagainflag == NO) {
       readagainflag = YES;
       SignatureLaunch();  // does not always work if manually closed
       goto readagain;
       }
**/
    if (size < 0) {
       sprintf(msgbuf, "!Failed to connect to signature port (%d).", size);
       msggerr(msgbuf);
       return(0);
       }

    if (flob_savebuf(sigbuf, size, "bmp", flobpath) < 0) {
       msggerr(msgbuf);
       return(-1);
       }
    move(flobpath,  &ghdhead.hdSfptr[5] );
    tmapfld(&ghdhead.hdSfptr[5] );
    if (flob_display(flobpath) < 0) {
       msggerr(msgbuf);
       return(-1);
       }

    return(0);
}

static int loadimagefile()
{
    long size;
    char *buffer;
    char filepath[200+1];
    char flobpath[FLOBSIZE+1];

    if ( (size = flob_getsize("dollar.jpg")) < 0L) {
        msggerr(msgbuf);
        return(-1);
        }
    if ( (buffer = malloc(size)) == NULLCHAR) {
       sprintf(msgbuf, "Unable to allocate memory %ld (%d)", size, errno);
       msggerr(msgbuf);
       return(-1);
       }

    if (flob_load("dollar.jpg", buffer) < 0) {
       msggerr(msgbuf);
       return(-1);
       }

/* text test */
/**
    if (flob_savebuf("This is a test", 15, "txt", flobpath) < 0) {
       msggerr(msgbuf);
       return(-1);
       }
**/

    if (flob_savebuf(buffer, size, "bmp", flobpath) < 0) {
       msggerr(msgbuf);
       return(-1);
       }
    move(flobpath,  &ghdhead.hdSfptr[5] );
    tmapfld(&ghdhead.hdSfptr[5] );
    if (flob_display(flobpath) < 0) {
       msggerr(msgbuf);
       return(-1);
       }

    free(buffer);
    return(0);
}


#include<stdio.h> 
#include <errno.h>
#include<sys/socket.h> 
#include<netinet/in.h> 
#include<arpa/inet.h> 
#include<netdb.h> 

int readsignature(ipaddress, portnumber, sigbuf, maxsize)
char *ipaddress;
long portnumber;
char *sigbuf;
long maxsize;
{ 
    int i;
    int keyhit;
    struct sockaddr_in pin; 
    int sock_descriptor; 
    int bytes_received = 0;
    struct hostent *server_host_name; 

    server_host_name=gethostbyname(ipaddress); 

    if ((portnumber < 1024 ) || (portnumber > 65535) ) {
        msggerr("Invalid port number: range 1024-65535\n");
        return(-1);
        }

    //remote host is local host  
    bzero(&pin,sizeof(pin));  /** like memset **/
    pin.sin_family=AF_INET;   /*** IP 4 internet protocol xxx.xxx.xxx.xxx ***/
    pin.sin_addr.s_addr=((struct in_addr *) (server_host_name->h_addr))->s_addr; 
#line 239 "inv.flx"
    pin.sin_port=htons(portnumber);  /* part of socket library */

    msgstat("Waiting for signature ... press ESCAPE key to exit.");
for (i=0; ;++i) {

    fcntl(0, F_SETFL, fcntl(0, F_GETFL, 0) | O_NDELAY);
    keyhit = getkey();
    fcntl(0, F_SETFL, fcntl(0, F_GETFL, 0) & ~O_NDELAY);
    if (keyhit == ESCAPEKEY) {
       break;
       }
/**
    keyhit = inkey();
    if (keyhit == 3) {
       break;
       }
**/
/**
    printf("%d (%d)\r\n", i, keyhit);
**/
    sock_descriptor=socket(AF_INET,SOCK_STREAM,6); 
    if (connect(sock_descriptor,(void *)&pin,sizeof(pin)) != 0 )  {
        close(sock_descriptor); 
        return(-2);
        }
    strcpy(sigbuf,"<SendSignature>"); //message that will be sent 
    if (send(sock_descriptor,sigbuf,strlen(sigbuf),0) < 0)  {
        close(sock_descriptor); 
        return(-2);
        }
    bzero(sigbuf, maxsize+2);
    if ((bytes_received=recv(sock_descriptor,sigbuf, maxsize,0)) < 0) {
        close(sock_descriptor); 
        return(-2);
        }
   /**
    printf("Bytes Received %d %d (%d)\r\n", bytes_received, sock_descriptor, errno);
#line 276 "inv.flx"
  **/
    if (bytes_received > 0 ) {
   /**
         printf("Bytes Received %i\r\n",bytes_received);
   **/
         close(sock_descriptor); 
         break;
         } 
    close(sock_descriptor); 
    }  /* end of for loop */

    msgstat("");

 return(bytes_received);
} 

 
 
int getClientAddress(ipaddress, pipport) /* get IP address of PC running Anita */ 
#line 295 "inv.flx"
char *ipaddress;
long *pipport;
{ 
    resetcrt();
    printf( "\033[31y%%sendip%%%%tx%%<cr>\033\134\r\n");
    fgets(ipaddress, MAXIPADDRESS, stdin);
    setcrt();
    strtrim(ipaddress, '\n');
    strtrim(ipaddress, '\r');
/**
    sprintf(msgbuf, "fgets(): %s", ipaddress);
    msggerr(msgbuf);
**/
    /* strcpy(ipaddress, "192.168.2.100"); */
   *pipport =  55001;
   return(0);
}

int SignatureLaunch()
{
    printf( "\033[1yc:\\Program Files\\AssortedBusinessSolutions\\SigCapPgm\\SigCap\033\134\r\n");
#line 316 "inv.flx"
    sleep(2);
    return(0);
}


