/************************************************************************
*                       - INFOFLEX System -
* This source code is CONFIDENTIAL and PROPRIETARY to CUSTOMWARE COMPUTING,
* INC. (CWC). The information contained herein may not be used, copied or
* disclosed in whole or in part except as permitted by written agreement
* signed by an officer of CWC.
*
* COPYRIGHT (c) 1986 CUSTOMWARE COMPUTING, INC., BURLINGAME, CALIFORNIA.
* ALL RIGHTS RESERVED.
*
* Version: %V%  %R%
* Date: %D%  %T%
*************************************************************************/

/* Important NOTE: TERMVAR here is not the same as the one for cwtmset.c */


#include "termflex.h"


testterm( termvar)
TERMVAR *termvar;
{
   char c;
   int dbreak = NO;

   printf( "NOT implemented at this time\n");
   if (dbreak == NO)
      return(0);

   for ( ;dbreak==NO;) {

       printf("\r\n\r\n\r\n\r\n");
       printf(" T E S T   T E R M I N A L   S E T T I N G S\n");
       printf(" -------------------------------------------\n\n");

       printf("     1.  Test CRT Cursor Address Settings.\n");
       printf("     2.  Test CRT Attribute Settings.\n");
       printf("     5.  Test ACTION Key Settings.\n");
       printf("     Q.  Quit.\n");
       printf("\n\n");
       printf("         Select Menu Option # ");

       c = getchar();
       getchar();
       switch(c) {
          case '1':
             curtest( termvar);
             break;
          case '2':
             attrtest( termvar);
             break;
          case '3':
             printf( "NOT implemented at this time\n");
             break;
          case '4':
             break;
          case '5':
             printf( "NOT implemented at this time\r\n");
             break;
          case 'b':
          case 'e':
          case 'E':
          case 'Q':
          case 'q':
             dbreak = YES;
             break;
          default:
             printf( "Bad entry --- Try Again");

          }
      }


    return( 0);
}



curtest( termvar)
TERMVAR *termvar;
{

    char line[ 40];

#ifdef UNIX
    setcrt();

       printf("\r\n\r\n\r\n\r\n");
       printf(" TEST CRT Cursor Addressing\n");


/* ************************** */
       printf("\r\n\r\n\r\n\r\n");
       printf("\r\nCursor Addressing Test - screen should: \r\n");
       printf("\r\n\t 1) Clear the screen");
       printf("\r\n\t 2) Display Message in middle of screen 'HELLO WORLD'");
       printf("\r\n\r\n\r\n");
       printf("\r\nPress Return key to perform test...");
       getline( line, sizeof line, stdin);
       fflush( stdout);
       if (line[0] == 'q' || line[0] == 'Q')
          return(0);

       clrscr();
/*
       printf( "%c%c%c%c%s", 27, 61, 12+32, 12+32, "TV925 cursor test");
       fflush( stdout);
*/
       spoke(9, 9,  "HELLO WORLD", 0, NULL );
       printf("\r\n123456789<--- Above 'H' should line up with '9' here");
       printf("\r\n\r\n\r\n\r\n");
       printf("\r\n Testing is complete - Press Return key\r\n");
       getline( line, sizeof line, stdin);

   resetcrt();

#endif

}

attrtest( termvar)
TERMVAR *termvar;
{

    char line[90];

#ifdef UNIX
    setcrt();

/* ************************** */
    printf("\r\n\r\n\r\n\r\n");
    printf("\r\nReverse Image Test - screen should: \r\n");
    printf("\r\n\t 1) Display 'HELLO WORLD' in reverse image");
    printf("\r\n\r\n\r\n");
    printf("\r\nPress Return key to perform test...");
    getline( line, sizeof line, stdin);
    fflush( stdout);
    if (line[0] == 'q' || line[0] == 'Q')
       return(0);

    clrscr();
    spoke(11, 11,  "HELLO WORLD", 0, REVERSE );

    printf("\r\n\r\n\r\n\r\n");
    printf("\r\n Testing is complete - Press Return key\r\n");
    getline( line, sizeof line, stdin);




   resetcrt();

#endif

}



