
#include <stdio.h>

main(argc, argv)
int argc;
char *argv[];
{
    if (argc < 3)  {
       fprintf(stderr, "Insufficient args: fromfile tofile\r\n");
       exit(1);
       }
    if (copyfile(argv[1], argv[2]) < 0) {
       exit(1);
       }
    exit(0);
}

copyfile(filefrom, fileto)
char *filefrom;
char *fileto;
{
     int linecount;
     char linebuf[1000];
     int length;
     FILE *fp_from;
     FILE *fp_to;

     fp_from  = fopen(filefrom, "r");
     if (fp_from == (FILE *)0) {
       fprintf(stderr, "fopen() can not open %s\n", filefrom);
       return(-1);
       }
     fp_to = fopen(fileto, "w");
     if (fp_to == (FILE *)0) {
       fprintf(stderr, "fopen() can not open %s\n", fileto);
       return(-1);
       }


     if (strncmp("/mnt/floppy", filefrom, 10) == 0)  {
         for (linecount=0;; ++linecount) {
             if (NULL == fgets(linebuf, sizeof(linebuf), fp_from) )
                break;
             length = strlen(linebuf);
             if (length > 1 && linebuf[length - 2] == '\r') {
                 linebuf[length - 2] = '\n';
                 linebuf[length - 1] = '\0';
                 }
             fputs(linebuf, fp_to);
             }
         }
     if (strncmp("/mnt/floppy", fileto, 10) == 0)  {
         for (linecount=0;; ++linecount) {
             if (NULL == fgets(linebuf, sizeof(linebuf), fp_from) )
                break;
             length = strlen(linebuf);
             if (length == 1) {
                 linebuf[0] = '\r';
                 linebuf[1] = '\n';
                 linebuf[2] = '\0';
                 }
             if (length > 1 && linebuf[length - 2] != '\r') {
                 linebuf[length - 1] = '\r';
                 linebuf[length] = '\n';
                 linebuf[length+1] = '\0';
                 }
             fputs(linebuf, fp_to);
             }
         }
     fclose(fp_to);
     fclose(fp_from);
     return(0);
}


