#!/usr/bin/perl 
#
#   by Gerard Menicucci   BDGP 7/13/2000
# 
#

use strict;

my $infilename = "amblist.ld";
#my $infilename = $ARGV[0];
my $useSTDIN = "N";
if (!defined $infilename || $infilename eq "") {
   $useSTDIN = "Y";
   }

if ($useSTDIN eq "N") { 
  open (INFILE, $infilename) or die "Can't find input file $infilename";
  }

my $line;
my @fields;
my $fixcount = 0;
my $rowcount = 0;
for ($rowcount=0; ;$rowcount++) {
  $line = <INFILE>;
  last if (!defined($line)); #EOF 
# print $line;
  chomp $line;
  @fields = split '\|', $line;
  if ($fields[3] =~/&/) {
      # print $fields[3] . "\n";
      $fields[3] =~s/^(.*)&(.*)$/$1/ ; 
      # print $fields[3] . "\n";
      $fixcount++;
      }
  print join('|', @fields) . "|" . "\n";
  }

print "\n$rowcount row(s) found ($fixcount)\n";

close INFILE;
